#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
extern double lotsize;
extern int ma1 =6;
extern int ma2 =18;
extern int ma3 =50;
extern int ma4 =200;

extern double sl;
extern double tp;
extern double risk;



int minbar =ma1;

bool canbuy;
bool cansell;
bool buycross=false;
bool sellcross=false; 

int OnInit()
  {

   return(INIT_SUCCEEDED);
  }
void OnDeinit(const int reason)
  {
   
  }
void OnTick()
  {
   cheackmacross();
   isthereactiveorder();
   if(canbuy==true )
     {
      opennew(OP_BUY);
     }
   if(cansell==true )
     {
      opennew(OP_SELL);
     }
     
  }
void isthereactiveorder(){
for( int i = 0 ; i < OrdersTotal() ; i++ ) {
      if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ) {
         Print("ERROR - Unable to select the order - ",GetLastError());
         break;
      } 
      if( OrderSymbol()==Symbol() && OrderType() == OP_BUY) canbuy=false;
      if( OrderSymbol()==Symbol() && OrderType() == OP_SELL) cansell=false;
      return;
        
}
}
double calculateLotSize(int stopLoss,int Risk)
{
   
     
    // Fetch some symbol properties
    double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
    double minLot  = MarketInfo(Symbol(), MODE_MINLOT); 
    double maxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
    double tickVal = MarketInfo(Symbol(), MODE_TICKVALUE);
 
    // Calculate the actual lot size
    double lotSize = AccountBalance() * Risk / 100 / (stopLoss * tickVal);
 
    return MathMin(
        maxLot,
        MathMax(
            minLot,
            NormalizeDouble(lotSize / lotStep, 0) * lotStep 
        )
    ); }

void opennew(int ordertype){
    RefreshRates();
    double openprice=0;
    double closeprice=0;
    double stopp=0;
    double takep=0;
    
    if(ordertype==OP_BUY){
            openprice=Ask;
            stopp=openprice-(sl*10*Point);
            takep=openprice+(tp*10*Point);
        }
    if(ordertype==OP_SELL){
        openprice=Bid;
            stopp=openprice+(sl*10*Point);
            takep=openprice-(tp*10*Point);
    }
    OrderSend(Symbol(),ordertype ,calculateLotSize(sl*10,risk),openprice,10,NormalizeDouble(stopp,Digits),NormalizeDouble(takep,Digits),NULL,0,0,clrBlue);
     
    return;
}
void cheackmacross(){
double currMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,1);
double prevMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,2);
double currMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,1);
double prevMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,2);
if(prevMA1>prevMA2 && currMA2>currMA1)
  {
   canbuy=true;
  }
if(prevMA1<prevMA2 && currMA2<currMA1)
  {
   cansell=true;
  }

} 